#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

struct msgbuf {
	long int type;
	char data[BUFSIZ];
};

void
usage (char *progname)
{

	fprintf (stderr, "Usage: %s type message\n", progname);
	fprintf (stderr, "\ttype: %s\n", "type in digit");
        exit (0);
}


int
main (int argc, char *argv[])
{
	char	*p;
	char	*progname;
	int	mqid;
	long 	type;
	struct msgbuf	message;

	progname = ((p = strrchr (argv[0], '/')) ? ++ p : argv[0]);
	if (argc != 2) {
		usage (progname);
	} else {
		type = atol (argv[1]);
		if (type <= 0) {
			fprintf (stderr, "Specify type in digit\n");
			usage (progname);
		}
	}

	if ((mqid = msgget ((key_t)1111, 0666 | IPC_CREAT)) == -1) {
		perror("msgget:");
		exit(-1);
	}

	while (1) {
		if (msgrcv (mqid, &message, BUFSIZ, type, 0) == -1) {
			perror("msgrcv:");
			break;
		} else {
			printf("message: %s\n", message.data);
		}
	}

	if(msgctl(mqid, IPC_RMID, NULL) == -1){
		perror ("msgctl:");
		exit (-1);
	}

	return 0;
}
