#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

struct msgbuf {
	long	type;
	char	data[BUFSIZ];
};

void
usage (char *progname)
{

	fprintf (stderr, "Usage: %s type message\n", progname);
	fprintf (stderr, "\ttype: %s\n\tstring: %s\n",
		"type in digit",
		"message in string"
	);
	exit (0);
}

int
main (int argc, char *argv[])
{
	char	*p;
	char	*progname;
	int	mqid;
	struct msgbuf	message;

	progname = ((p = strrchr (argv[0], '/')) ? ++ p : argv[0]);
	if (argc != 3) {
		usage (progname);
	} else {
		if((message.type = atol (argv[1])) <= 0){
			fprintf (stderr,"Specify type in digit.\n");
			usage (progname);
		}

		if (strlen (argv[2]) < (BUFSIZ - sizeof (long))) {
			strncpy (message.data, argv[2], BUFSIZ);
		} else {
			fprintf (stderr, "Message too large\n");
			exit (-1);
		}
	}

	if ((mqid = msgget ((key_t)1111, 0666 | IPC_CREAT)) == -1){
		perror ("msgget:");
		exit (-1);
	}

	if(msgsnd (mqid, &message, BUFSIZ, 0) == -1){
		perror ("msgsnd:");
		exit (-1);
	}

	return 0;
}
